#!/usr/bin/python3

from qtvcp.lib.qt_vismach.primitives import *
from qtvcp.lib.qt_vismach.qt_vismach import *

import hal
import math
import sys

c = hal.component("vm_test")
c.newpin("joint0", hal.HAL_FLOAT, hal.HAL_IN)
c.newpin("joint1", hal.HAL_FLOAT, hal.HAL_IN)
c.newpin("joint2", hal.HAL_FLOAT, hal.HAL_IN)
c.ready()


work = Capture()
tooltip = Capture()

ram = CylinderZ(50.0, 50.0, 100.0, 50.0)
ram = Color([1,1,1,1],[ram])
ram = Translate([ram], 0.0, 0.0, -35.0)
ram = HalTranslate([ram], c, "joint2", 0.0, 0.0, 1.0)

table = Collection([work,tooltip, BoxCenteredXY(0.0, 150.0, 15.0)])
table = Color([2,2,2,2],[table])
table = Translate([table], 0.0, 0.0, 0.0)
table = HalTranslate([table], c, "joint1", 1.0, 0.0, 0.0)

model = Collection ([ram,table])

class Window(QWidget):

    def __init__(self):
        super(Window, self).__init__()
        self.glWidget = GLWidget()
        v = self.glWidget
        v.set_latitudelimits(-180, 180)

        world = Capture()

        v.model = Collection([model, world])
        size = 600
        v.distance = size * 3
        v.near = size * 0.01
        v.far = size * 10.0
        v.tool2view = tooltip
        v.world2view = world
        v.work2view = work

        mainLayout = QHBoxLayout()
        mainLayout.addWidget(self.glWidget)
        self.setLayout(mainLayout)


# but it you call this directly it should work too

if __name__ == '__main__':
    import sys
    from PyQt5.QtWidgets import (QApplication, QWidget)

    app = QApplication(sys.argv)
    window = Window()
    window.show()
    sys.exit(app.exec_())
